class Message {
	private:
		int lifetime;
		int x, y;
		Sprite *font;
		byte *screen;

		char *message;



	public:
		Message *next;

		Message(char *string, int row, int life, Sprite* fnt, byte *scrn, Message *mnext)
		{
			x = 20 - strlen(string)/2;
			y = row;
			lifetime = life;
			font = fnt;
			screen = scrn;

			message = new char [strlen(string)];

			strcpy(message, string);

			next = mnext;

		};

		Message()
		{
			x = 20;
			y = 5;
			lifetime = 0;
			font = NULL;
			screen = vga;
			message = "\0";
			next = NULL;
		};

		void Display()
		{
			gputs(x,y,message,*font,screen);
			lifetime--;
		}

		int active()
		{
			return (lifetime!=0);
		};

		~Message()
		{
			delete [] message;
		}
};
