#include <time.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

extern unsigned char far * vga ;
int delay_time = 0;

#include "sprite.h"
#include "bullet.h"
#include "powerup.h"

#include "ship.h"

#include "enemy.h"
#include "player.h"

#include "message.h"




// *********************************************************************

int Play(byte *screen, FILE *fp)
{
	time_t very_start, very_finish;
	long int frames = 0;

//	FILE *fp;

	int state=0;


	Message * messages = NULL;
	Message * mtemp, *mcurrent, *mlast;

	PowerUp * powerUps = NULL;
	PowerUp * temp, *current, *last;

	// load sprites

//	fp = fopen("spaced.dat", "rb");

	Sprite player_bullet("bullet1.vga",fp);
	Sprite enemy_1_bullet("bullet2.vga",fp);
	Sprite enemy_2_bullet("bullet3.vga",fp);
	Sprite enemy_3_bullet("bullet4.vga",fp);
	Sprite enemy_4_bullet("bullet5.vga",fp);
	Sprite enemy_5_bullet("bullet6.vga",fp);
	Sprite player_bullet_explosion("bullexpl.vga",fp);
	Sprite city_death("citydeth.vga",fp);
	Sprite city_explosion("cityexpl.vga",fp);
	Sprite enemy_1_ship("enemy1.vga",fp);
	Sprite enemy_2_ship("enemy2.vga",fp);
	Sprite enemy_3_ship("enemy3.vga",fp);
	Sprite enemy_4_ship("enemy4.vga",fp);
	Sprite enemy_5_ship("enemy5.vga",fp);
	Sprite player_expl("expl.vga",fp);
	Sprite enemy_1_expl("expl1.vga",fp);
	Sprite enemy_2_expl("expl2.vga",fp);
	Sprite enemy_3_expl("expl3.vga",fp);
	Sprite enemy_4_expl("expl4.vga",fp);
	Sprite enemy_5_expl("expl5.vga",fp);
	Sprite powerup_firepower("firepowr.vga",fp);
	Sprite font( "font.vga",fp);
	Sprite city( "newmelb.vga",fp);
	Sprite powerup_general("powerup.vga",fp);
	Sprite player_shield("shield.vga",fp);
	Sprite player_ship("ship.vga",fp);
	Sprite powerup_shield("shldpowr.vga",fp);


  //	fclose(fp);

	Sprite city_backup(city);


	Player player(&player_ship, &player_expl, &player_bullet, 160 - player_ship.sx/2, screen_bottom - player_ship.sy);
	player.shield_sprite = &player_shield;
	player.bullet_explosion = &player_bullet_explosion;

	int num_enemies=6;

	Enemy *enemy;
	enemy = new Enemy [num_enemies];
	if(enemy ==NULL) return 1;

	enemy[0].Init(&enemy_1_ship, &enemy_1_expl, &enemy_1_bullet, 30, 50,1,1);
	enemy[0].dx = 5;	enemy[0].dy = 0;
	enemy[0].state = 1;

	enemy[1].Init(&enemy_2_ship, &enemy_2_expl, & enemy_2_bullet, 100, 80,2,1);
	enemy[1].dx = 7;	enemy[1].dy = 0;
	enemy[1].state = 1;

	enemy[2].Init(&enemy_3_ship, &enemy_3_expl, & enemy_3_bullet, 150, 100,3,1);
	enemy[2].dx = -7;	enemy[2].dy = 0;
	enemy[2].state = 1;

	enemy[3].Init(&enemy_1_ship, &enemy_1_expl, & enemy_1_bullet, 205, 10,1,1);
	enemy[3].dx = -7;	enemy[3].dy = 0;
	enemy[3].state = 1;

	enemy[4].Init(&enemy_4_ship, &enemy_4_expl, & enemy_4_bullet, 320, 50,4,2);
	enemy[4].dx = -7;	enemy[4].dy = 0;
	enemy[4].state = 1;

	enemy[5].Init(&enemy_5_ship, &enemy_5_expl, & enemy_5_bullet, 0, 20,5,5);
	enemy[5].dx = 3;	enemy[3].dy = 0;
	enemy[5].state = 1;

		// read hi score
/*	fp = fopen("hiscore","rt");
	fscanf(fp,"%ld",&player.hi_score);
	player.hi_score ^= 123456;				// de encrypt hi score :)
	fclose(fp);
*/
//	fp = fopen("spaced.dat", "rb");
//	fseek(fp, 4, SEEK_END);
/*
	player.hi_score = fgetc(fp);
	player.hi_score += (fgetc(fp)<<8);
	player.hi_score += (fgetc(fp)<<16);
	player.hi_score += (fgetc(fp)<<24);
*/

	player.hi_score = 0;
//	fclose(fp);

	strcpy(player.Hi_score_string, "Hi:");
	strcat(player.Hi_score_string, itoa(player.hi_score, player.temp_string, 10));
	player.Hi_score_string_len = strlen(player.Hi_score_string);

	time(&very_start);
	while (state==0)			// 0 - play on, 1 - quit , 2 - game over
	{
		city.copy(0,screen_bottom-city.sy, screen);


//		if(!random(100) && enemy[5].state==0 && score>3000)
//		{
//			enemy[5].state=1;
//			enemy[5].x = random(320);
//		}

//		if(player.score>2000 && enemy[4].state==0)
//			enemy[4].state=1;

		if(!random(250))	// drop a power up down
		{
			switch(random(5))
			{
				case 0:
						temp = new PowerUp( random(200)+60, 30, 0, 4, &powerup_firepower, 1);
						break;
				case 1:
						temp = new PowerUp( random(200)+60, 30, 0, 4, &powerup_shield, 2);
						break;
				case 2:
						temp = new PowerUp( random(200)+60, 30, 0, 4, &powerup_shield, 3);
						break;
				case 3:
						temp = new PowerUp( random(200)+60, 30, 0, 4, &powerup_general, 4);
						break;
				case 4:
						temp = new PowerUp( random(200)+60, 30, 0, 4, &powerup_general, 5);
						break;


			}


			if(temp)
			{
				temp->next = powerUps;

				powerUps = temp;
			}
		}


		last = current = powerUps;
		while(current)
		{
			current->draw(screen);

			if(current->move())		// out of bounds
			{
					// delete from list
				if(powerUps == current) 	// first in list
				{
					powerUps = current->next;
				} else
				{
					last->next = current->next;
				}

				temp = current;
				current = current->next;
				delete temp ;
			} else if(player.collected(current))
			{
				switch(current->action)
				{
					case 1:         	// increase fire power
							player.gun_type++;
							player.charge = player.max_charge;
							if(player.gun_type>player.max_fire_power)
								player.gun_type= player.max_fire_power;

							mtemp = new Message("Firepower Increase", 10, 10, &font, screen, messages);
							if(mtemp)
								messages = mtemp;

								 break;
					case 2:				// increase shields
							player.max_shield += 5;
							player.shield = player.max_shield;
							mtemp = new Message("Shield Increase", 10, 10, &font, screen, messages);
							if(mtemp)
								messages = mtemp;
							break;
					case 3:				// increase shields recovery
							player.recharge_shield_rate++;
							player.shield = player.max_shield;
							mtemp = new Message("Shield Recharge Increase", 10, 10, &font, screen, messages);
							if(mtemp)
								messages = mtemp;
							break;
					case 4:				// increase max power
							player.max_charge += 5;
							player.charge = player.max_charge;
							mtemp = new Message("Power Increase", 10, 10, &font, screen, messages);
							if(mtemp)
								messages = mtemp;
							break;

					case 5:				// recharge power quicker
							mtemp = new Message("Power Recharge Increase", 10, 10, &font, screen, messages);
							if(mtemp)
								messages = mtemp;
							player.recharge_rate++;
							break;

					default:	 break;
				}

					// delete from list
				if(powerUps == current) 	// first in list
				{
					powerUps = current->next;
				} else
				{
					last->next = current->next;
				}

				temp = current;
				current = current->next;
				delete temp ;

			} else
			{
				last = current;
				current = current->next;
			}

		}



		for(int i=0;i<num_enemies;i++)
			enemy[i].update(player, city, city_death, city_explosion, screen);


		player.update(enemy ,num_enemies, screen);

		state = player.getInput(city,city_backup,player_bullet, enemy, num_enemies, font, screen);

		player.DrawStatus(font, screen);




		if(messages)	// messages will be a queue, with messages at the front
							// for the moment it is a stack :)
		{
			if(messages->active())
			{
				messages->Display();

			} else		// remove it
			{
				mtemp = messages;
				messages = messages->next;
				delete mtemp;
			}

		}
		waitForRetrace();
		flipAndClear(screen, vga, 0);

		frames ++;

		if(delay_time)
		{
			delay(delay_time);
		}
	}

	time(&very_finish);

	fp = fopen("frames","a+t");
	if(fp!=NULL)
	{
		fprintf(fp,"frames: %ld time: %ld \n\r", frames, very_finish- very_start);
	}
	fclose(fp);

	if(player.score>player.hi_score)
		player.hi_score = player.score;

	strcpy(player.Hi_score_string, "Hi:");
	strcat(player.Hi_score_string, itoa(player.hi_score, player.temp_string, 10));
	player.Hi_score_string_len = strlen(player.Hi_score_string);
		// save hi score
/*	fp = fopen("hiscore","wt");
	player.hi_score ^= 123456;				// encrypt it :)
	fprintf(fp,"%ld",player.hi_score);
	fclose(fp); */

//	fp = fopen("spaced.dat", "rb");
//	long pos = ftell(fp);
//	fseek(fp, pos - 4, SEEK_SET);
/*	fseek(fp, 4, SEEK_END);
	long pos = ftell(fp);

	fputc( player.hi_score&0xff, fp);
	fputc( (player.hi_score>>8)&0xff, fp);
	fputc( (player.hi_score>>16)&0xff, fp);
	fputc( (player.hi_score>>24)&0xff, fp);
*/
//	fclose(fp);

	return state;
}

// *********************************************************************


void main(int argc, char *argv[])
{
	byte * screen;
	int mouse=0;
	int state=0;
	char c;

	screen = new byte [64000];
	if(screen==NULL) return;

	randomize();
	go256();

	// initialize mouse
	asm mov ax, 0
	asm int 33h

	asm mov mouse, ax

	if(mouse != 0xffff)
	{
		textmode();
		delete [] screen;

		printf("Sorry, a mouse is required to play this game.\n\r");
		return;
	}

	{   // set a delay for faster computers - limit to 15fps

		float max_fps = 25;

		if(argc==2)
		{
			max_fps = atoi(argv[1]);
		}
		int i;
		float n = 100.0; 	   // number of frames to draw
		float fps, spf;   	// frames per second, seconds per frame
		float seconds;			// time taken to draw 200 frames

		clock_t start, finish;

		start = clock();
		for(i=0;i<n;i++)		// flip to screen 200 times
		{
			waitForRetrace();
			flipAndClear(screen,vga,0);
		}
		finish = clock();


		seconds = ((float)(finish-start))/CLK_TCK;

		fps = n/seconds;
		spf = seconds/n;

		if(fps>max_fps)
		{
						// delay = time taken to draw one frame times the
						// number of extra frames drawn...
						// (times 1000 to put it in milliseconds)
			delay_time = ((fps-max_fps)*spf) * 1000.0;
			delay_time /= max_fps;		// only do the delay once each frame :)
		}
		else
		{
			delay_time = 0;
		}

	}


	while(state!=1)
	{

			// load splash screen
/*		FILE *fp = fopen( "splash.vga","rb");
		if(fp!=NULL)
		{
			rewind(fp);
			fgetc(fp);	// discard image size, 320*200
			fgetc(fp);
			fgetc(fp);
			fgetc(fp);
			fread( screen, 1, 64000, fp);	// load into menu memory for starters...
			fclose(fp);
*/
		FILE *fp = fopen( "spaced.dat","rb");
		if(fp!=NULL)
		{
			rewind(fp);

//			fseek(fp, 4 + 64004, SEEK_END);		// goto end of file, then back
													// four to skip hiscore, then back
													// to start of splash.vga
			fgetc(fp);	// discard image size, 320*200
			fgetc(fp);
			fgetc(fp);
			fgetc(fp);
			fread( screen, 1, 64000, fp);	// load into menu memory for starters...
//			fclose(fp);


			flip(screen,vga);

				// wait for mouse click
			int x, y;
			int button=0;

			while(!button && !kbhit())
			{
							// read mouse position & buttons
				asm mov ax, 3
				asm int 33h
				asm mov word ptr button, bx

				asm mov word ptr x, cx
				asm mov word ptr y, dx
			}

			if(kbhit())
			{
				c = getch();

				if(c==27)
				{
					textmode();

					delete [] screen;

					return;
				}
			}
		}

		state = Play(screen, fp);

		fclose(fp);
	}

	textmode();

	delete [] screen;


}




